/*
 * Copyright 2011 maru project.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.maru.m4hv.extensions.validator;

import static org.maru.m4hv.extensions.util.Condition.isLessThan;

import java.text.MessageFormat;

abstract class AbstractHmsValidator<T> {

    protected int start;

    protected int end;

    protected void checkProperTimeRange(String category, int start, int end) {
        if (!isLessThan(start, end)) {
            String errorMessage = MessageFormat.format("The start {0} [{1}] must be less than the end {0} [{2}]", category, start, end);
            throw new IllegalArgumentException(errorMessage);
        }
    }

    protected abstract Integer getValueAsActualType(T value);

}
